SystemOrganization addCategory: #'Equipement-TIT'!

Object subclass: #PLCInput
	instanceVariableNames: 'val1'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Equipement-TIT'!

PLCInput subclass: #AnalogInput
	instanceVariableNames: 'val'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Equipement-TIT'!

!AnalogInput methodsFor: 'accessing' stamp: 'KappelCondevaux 4/27/2012 16:38'!
pointValue
	^32767 min: (0 max: (val ifNil:[0])).
	! !

!AnalogInput methodsFor: 'accessing' stamp: 'KappelCondevaux 4/27/2012 16:11'!
pointValue: aSmallInteger 

val:= aSmallInteger.
! !

PLCInput subclass: #DigitalInput
	instanceVariableNames: 'etat'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Equipement-TIT'!

!DigitalInput methodsFor: 'as yet unclassified' stamp: 'KappelCondevaux 5/25/2012 09:49'!
etatGen 
	^etat.! !

!DigitalInput methodsFor: 'accessing' stamp: 'KappelCondevaux 5/25/2012 10:04'!
stateOff
	^etat := false.! !

!DigitalInput methodsFor: 'accessing' stamp: 'KappelCondevaux 5/25/2012 10:04'!
stateOn
	etat:=true.! !

!PLCInput methodsFor: 'accessing' stamp: 'KappelCondevaux 5/25/2012 09:18'!
label
	^val1 ifNil:[0].! !

!PLCInput methodsFor: 'accessing' stamp: 'KappelCondevaux 5/25/2012 09:19'!
label: aByteString 
	^val1:= aByteString.! !

Object subclass: #RFGenerator
	instanceVariableNames: 'pwrOn rfOn myGenerator pwron rfon inpwron inpfon'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Equipement-TIT'!

!RFGenerator methodsFor: 'as yet unclassified' stamp: 'KappelCondevaux 5/25/2012 09:29'!
currentPower

	| inputPower |
	pwron := DigitalInput new label: 'PWRON'.
	rfon := DigitalInput new label: 'RFON'.
	inputPower := AnalogInput new label: 'QPW1'.

	myGenerator := RFGenerator new.
	myGenerator
 	 inputPwron: pwron;
 	 inputRfon: rfon;
 	 inputCurrentPower: inputPower.! !

!RFGenerator methodsFor: 'accessing' stamp: 'GiraudBouvier 5/25/2012 10:56'!
inputCurrentPower: aByteString 
	! !

!RFGenerator methodsFor: 'accessing' stamp: 'KappelCondevaux 5/25/2012 09:46'!
inputPwron: aDigitalInput 
		inpwron := aDigitalInput.
! !

!RFGenerator methodsFor: 'accessing' stamp: 'KappelCondevaux 5/25/2012 09:47'!
inputRfon: aDigitalInput 
	inpfon := aDigitalInput .! !

!RFGenerator methodsFor: 'accessing' stamp: 'KappelCondevaux 5/25/2012 09:58'!
isRunning
	^inpwron etatGen
		and: [inpfon etatGen].! !

TestCase subclass: #AnalogInputTest
	instanceVariableNames: 'power jackyInput'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Equipement-TIT'!

!AnalogInputTest methodsFor: 'as yet unclassified' stamp: 'KappelCondevaux 4/27/2012 14:36'!
testDefautResultShouldBe0
	power := AnalogInput new.
	power label: 'QPW1'.
	self assert: 0 = power pointValue.! !

!AnalogInputTest methodsFor: 'as yet unclassified' stamp: 'GiraudBouvier 5/25/2012 10:50'!
testLabel
	power:=AnalogInput new.
	power label:'test'.
	self assert: 'test'= power label.! !

!AnalogInputTest methodsFor: 'as yet unclassified' stamp: 'KappelCondevaux 4/27/2012 16:18'!
testValueDownNegative1
	power := AnalogInput new.
	power pointValue: -1.
	self assert: 0 = power pointValue.! !

!AnalogInputTest methodsFor: 'as yet unclassified' stamp: 'KappelCondevaux 4/27/2012 16:38'!
testValueUpPositive40000
	power := AnalogInput new.
	power pointValue: 40000.
	self assert: 32767 = power pointValue.! !

!AnalogInputTest methodsFor: 'as yet unclassified' stamp: 'KappelCondevaux 4/27/2012 15:07'!
testWith15000ResultShouldBe15000
	power := AnalogInput new.
	power pointValue: 15000.
	self assert: 15000 = power pointValue.! !

TestCase subclass: #RFGeneratorTest
	instanceVariableNames: 'pwron rfon myGenerator fron inputPower'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Equipement-TIT'!

!RFGeneratorTest methodsFor: 'running' stamp: 'GiraudBouvier 5/25/2012 10:55'!
setUp 

	pwron := DigitalInput new.
	pwron label: 'PWRON'.
	
	rfon := DigitalInput new.
	rfon label:'RFON'.
	inputPower := AnalogInput new label: 'QPW1'.
	myGenerator := RFGenerator new.
	myGenerator
		inputPwron: pwron;
		inputRfon: rfon;
		inputCurrentPower: inputPower.
		


  
		
	
! !

!RFGeneratorTest methodsFor: 'tests' stamp: 'GiraudBouvier 5/25/2012 10:50'!
testCas1
	pwron stateOff.
	rfon stateOff.
	self deny: myGenerator isRunning.! !

!RFGeneratorTest methodsFor: 'tests' stamp: 'GiraudBouvier 5/25/2012 10:50'!
testCas2
	pwron stateOn.
	rfon stateOff.
	self deny: myGenerator isRunning.! !

!RFGeneratorTest methodsFor: 'tests' stamp: 'GiraudBouvier 5/25/2012 10:50'!
testCas3
	pwron stateOff.
	rfon stateOn.
	self deny: myGenerator isRunning.! !

!RFGeneratorTest methodsFor: 'tests' stamp: 'GiraudBouvier 5/25/2012 10:50'!
testCas4
	pwron stateOn.
	rfon stateOn.
	self assert: myGenerator isRunning.
! !
